import { ElementRef, TemplateRef, AfterContentInit, AfterViewInit, EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
export declare class SuiMultiSelect implements AfterContentInit, AfterViewInit {
    private el;
    private _dropdownMenu;
    private _dropdownService;
    private _searchService;
    private renderedOptions;
    private renderedOptionsSubscriptions;
    private renderedSelectedOptions;
    private renderedSelectedOptionsSubscriptions;
    selectedOptions: any[];
    maxSelected: number;
    private maxSelectedReached;
    searchClasses: boolean;
    tabIndex: number;
    isSearchable: boolean;
    placeholder: string;
    options: any[];
    displayField: string;
    keyField: string;
    private query;
    selectedOptionsChange: EventEmitter<any>;
    onItemSelected: EventEmitter<any>;
    optionTemplate: TemplateRef<any>;
    readonly isActive: boolean;
    isOpen: boolean;
    isDisabled: boolean;
    private readonly results;
    private readonly availableOptions;
    constructor(el: ElementRef);
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    private renderedOptionsSubscribe();
    private renderedSelectedOptionsSubscribe();
    selectOption(option: any): void;
    deselectOption(option: any): void;
    private focusSearch();
    private focusFirstItem();
    writeValue(value: any): void;
    click(event: MouseEvent): boolean;
    keypress(event: KeyboardEvent): void;
    searchKeyDown(event: KeyboardEvent): void;
}
export declare const CUSTOM_VALUE_ACCESSOR: any;
export declare class SuiMultiSelectValueAccessor implements ControlValueAccessor {
    private host;
    onChange: () => void;
    onTouched: () => void;
    constructor(host: SuiMultiSelect);
    writeValue(value: any[]): void;
    registerOnChange(fn: () => void): void;
    registerOnTouched(fn: () => void): void;
}
